From 6edeaab3cb21824c0e24c9c34e50824ca1cd45ed Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 02 2020 06:48:37 +0000
Subject: [PATCH 1216/2232] Treat un-namespaced items the same as root namespace


---

diff --git a/gen/src/nested.rs b/gen/src/nested.rs
index 143f6ec..8a1dd6d 100644
--- a/gen/src/nested.rs
+++ b/gen/src/nested.rs
@@ -29,7 +29,7 @@ fn sort_by_inner_namespace(apis: Vec<&Api>, depth: usize) -> NamespaceEntries {
     let mut index_of_namespace = Map::new();
 
     for api in &apis {
-        if let Some(first_ns_elem) = api.namespace().and_then(|ns| ns.iter().nth(depth)) {
+        if let Some(first_ns_elem) = api.namespace().iter().nth(depth) {
             match index_of_namespace.get(first_ns_elem) {
                 None => {
                     index_of_namespace.insert(first_ns_elem, nested_namespaces.len());
diff --git a/syntax/namespace.rs b/syntax/namespace.rs
index 02e5dc2..160650f 100644
--- a/syntax/namespace.rs
+++ b/syntax/namespace.rs
@@ -86,13 +86,13 @@ impl<'a> FromIterator<&'a Ident> for Namespace {
 }
 
 impl Api {
-    pub fn namespace(&self) -> Option<&Namespace> {
+    pub fn namespace(&self) -> &Namespace {
         match self {
-            Api::CxxFunction(efn) | Api::RustFunction(efn) => Some(&efn.ident.cxx.namespace),
-            Api::CxxType(ety) | Api::RustType(ety) => Some(&ety.ident.cxx.namespace),
-            Api::Enum(enm) => Some(&enm.ident.cxx.namespace),
-            Api::Struct(strct) => Some(&strct.ident.cxx.namespace),
-            Api::Impl(_) | Api::Include(_) | Api::TypeAlias(_) => None,
+            Api::CxxFunction(efn) | Api::RustFunction(efn) => &efn.ident.cxx.namespace,
+            Api::CxxType(ety) | Api::RustType(ety) => &ety.ident.cxx.namespace,
+            Api::Enum(enm) => &enm.ident.cxx.namespace,
+            Api::Struct(strct) => &strct.ident.cxx.namespace,
+            Api::Impl(_) | Api::Include(_) | Api::TypeAlias(_) => Default::default(),
         }
     }
 }

